#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

#define cerr if (false) cerr

typedef vector<int> vi;
typedef vector<vi> t_graph;

vi st, in_st, in_rn, visited;
vector<vi> rings;

void go(int v, int p, const t_graph& g) {
    in_st[v] = true;
    st.push_back(v);
    visited[v] = true;

    for (size_t i = 0; i < g[v].size(); ++i) {
        int u = g[v][i];
        if (u == p) continue;
        if (in_st[u]) {
            vi ring(1, u);
            while (true) {
                ring.push_back(st.back());
                in_st[st.back()] = false;
                in_rn[st.back()] = rings.size();
                if (st.back() == u)
                    break;
                st.pop_back();
            }
            rings.push_back(ring);
            st.pop_back();
            continue;
        }
        if (visited[u]) continue;

        go(u, v, g);
    }

    if (in_st[v]) {
        rings.push_back(vi(1, v));
        in_st[v] = false;
        in_rn[v] = rings.size() - 1;
        st.pop_back();
    }
}

int solve(int s, const t_graph& g) {
    if (g.size() == 1)
        return 1;

    visited.resize(g.size());
    in_st.resize(g.size());
    in_rn.resize(g.size());

    go(s, -1, g);
    int res = 0;

    for (size_t i = 0; i < rings.size(); ++i) {

        int v = rings[i][0];
        if (rings[i].size() == 1) {
            if (g[v].size() == 1 && v != s) {
                ++res;
            }
        } else {
            int p1 = rings[i][1];
            int p2 = rings[i][rings[i].size() - 2];
            if (g[p1].size() == 2)
                ++res;
            if (g[p2].size() == 2)
                ++res;
        }
    }

    return res;
}

int main() {
    freopen("ringsis.txt", "r", stdin);
    freopen("ringval.txt", "w", stdout);

    int n, m, s;
    t_graph g;

    cin >> n >> m >> s;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y;
        --x; --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    cout << solve(s - 1, g) << endl;

    return 0;
}
